# Class BaseAgentConfig

java.lang.Object
com.google.adk.agents.BaseAgentConfig

Direct Known Subclasses:
  `LlmAgentConfig, LoopAgentConfig, ParallelAgentConfig, SequentialAgentConfig`

public class BaseAgentConfig extends Object
Base configuration for all agents with subagent support.

TODO: Config agent features are not yet ready for public use.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `BaseAgentConfig.AgentRefConfig`
  Configuration for referencing other agents (subagents).
  `static class`
  `BaseAgentConfig.CallbackRef`
  Reference to a callback stored in the ComponentRegistry.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BaseAgentConfig()`
  `BaseAgentConfig(String agentClass)`
  `BaseAgentConfig(String name, String description, String agentClass)`
  Constructor with basic fields.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `com.google.common.collect.ImmutableList<BaseAgentConfig.CallbackRef>`
  `afterAgentCallbacks()`
  `String`
  `agentClass()`
  `com.google.common.collect.ImmutableList<BaseAgentConfig.CallbackRef>`
  `beforeAgentCallbacks()`
  `String`
  `description()`
  `String`
  `name()`
  `void`
  `setAfterAgentCallbacks(List<BaseAgentConfig.CallbackRef> afterAgentCallbacks)`
  `void`
  `setAgentClass(String agentClass)`
  `void`
  `setBeforeAgentCallbacks(List<BaseAgentConfig.CallbackRef> beforeAgentCallbacks)`
  `void`
  `setDescription(String description)`
  `void`
  `setName(String name)`
  `void`
  `setSubAgents(List<BaseAgentConfig.AgentRefConfig> subAgents)`
  `com.google.common.collect.ImmutableList<BaseAgentConfig.AgentRefConfig>`
  `subAgents()`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### BaseAgentConfig

    public BaseAgentConfig()

  - ### BaseAgentConfig

    public BaseAgentConfig(String agentClass)

  - ### BaseAgentConfig

    public BaseAgentConfig(String name, String description, String agentClass)
    Constructor with basic fields.
    Parameters:
      `name` - The agent name
      `description` - The agent description
      `agentClass` - The agent class name

- ## Method Details

  - ### name

    public String name()

  - ### setName

    public void setName(String name)

  - ### description

    public String description()

  - ### setDescription

    public void setDescription(String description)

  - ### setAgentClass

    public void setAgentClass(String agentClass)

  - ### agentClass

    public String agentClass()

  - ### subAgents

    public com.google.common.collect.ImmutableList<BaseAgentConfig.AgentRefConfig> subAgents()

  - ### setSubAgents

    public void setSubAgents(List<BaseAgentConfig.AgentRefConfig> subAgents)

  - ### beforeAgentCallbacks

    public com.google.common.collect.ImmutableList<BaseAgentConfig.CallbackRef> beforeAgentCallbacks()

  - ### setBeforeAgentCallbacks

    public void setBeforeAgentCallbacks(List<BaseAgentConfig.CallbackRef> beforeAgentCallbacks)

  - ### afterAgentCallbacks

    public com.google.common.collect.ImmutableList<BaseAgentConfig.CallbackRef> afterAgentCallbacks()

  - ### setAfterAgentCallbacks

    public void setAfterAgentCallbacks(List<BaseAgentConfig.CallbackRef> afterAgentCallbacks)